package be.iminds.ilabt.jfed.experimenter_gui.bugreporting;

import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.log.cache.ApiCallDetailsRef;

import java.time.Instant;
import java.util.ArrayList;
import java.util.List;

/**
 * User: twalcari
 * Date: 12/16/2015
 * Time: 09:38
 */
public class SerializableTaskExecution {
    private String id, name;
    private TaskExecution.TaskState state;
    private String taskClass;

    private Instant start, end;

    private List<ApiCallDetailsRef> apiCallDetails = new ArrayList<>();

    public SerializableTaskExecution(){}

    public SerializableTaskExecution(TaskExecution<?> taskExecution) {
        this.id =taskExecution.getId();
        this.name = taskExecution.getName();
        this.state = taskExecution.getState();
        this.taskClass = taskExecution.getTask().getClass().getName();
        this.start = taskExecution.getRunStart() != null ? taskExecution.getRunStart().toInstant() : null;
        this.end = taskExecution.getRunStop() != null ? taskExecution.getRunStop().toInstant() : null;

        this.apiCallDetails.addAll(taskExecution.getApiCallHistory());
    }


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public TaskExecution.TaskState getState() {
        return state;
    }

    public void setState(TaskExecution.TaskState state) {
        this.state = state;
    }

    public String getTaskClass() {
        return taskClass;
    }

    public void setTaskClass(String taskClass) {
        this.taskClass = taskClass;
    }

    public Instant getStart() {
        return start;
    }

    public void setStart(Instant start) {
        this.start = start;
    }

    public Instant getEnd() {
        return end;
    }

    public void setEnd(Instant end) {
        this.end = end;
    }

    public List<ApiCallDetailsRef> getApiCallDetails() {
        return apiCallDetails;
    }

    public void setApiCallDetails(List<ApiCallDetailsRef> apiCallDetails) {
        this.apiCallDetails = apiCallDetails;
    }
}
